					//*********************************************************************************
					//
					//     This program is free software; you can redistribute it and/or modify
					//     it under the terms of the GNU General Public License as published by
					//     the Free Software Foundation; either version 2 of the License, or
					//     (at your option) any later version.
					//
					//     This program is distributed in the hope that it will be useful,
					//     but WITHOUT ANY WARRANTY; without even the implied warranty of
					//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
					//     GNU General Public License for more details.
					//
					//    You should have received a copy of the GNU General Public License along
					//    with this program; if not, write to the Free Software Foundation, Inc.,
					//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
					//    
					//*********************************************************************************

					ErrMatLoc=gslgmp_matrix_calloc(NOMEGA,NOMEGA);

					mpfr_t errtmp,errtmp2;
					mpfr_init2(errtmp,PRECBITS);
					mpfr_init2(errtmp2,PRECBITS);

					//*********************************************************
					//	Calculate (d^2Q/dAdA)^-1=(+alpha*d2SdAdA-d2LdAdA)^-1
					//*********************************************************
	
					gslgmp_vector* onevec,*dwvec;
					dwvec = gslgmp_vector_calloc(NOMEGA);
					onevec = gslgmp_vector_calloc(NOMEGA);
					for(int i=0;i<NOMEGA;i++) gslgmp_vector_set_ui(onevec,i,1);
					
/*					fprintf(stderr, "\n\nDEBUG: %e %e => %e\n\n", domega[1], domega[0],domega[1]-domega[0]);
					fprintf(stderr, "\n\nDEBUG: %e %e => %e\n\n", domega[NOMEGA-1], domega[NOMEGA-2],domega[NOMEGA-1]-domega[NOMEGA-2]);*/
					
					append_dw(dwvec,onevec,omega,NOMEGA,HPNUM,OMEGAHPMIN,OMEGAHPMAX);

// 					gmpPVec(dwvec);
	
					for(int dw1=0;dw1<NOMEGA;dw1++){
					for(int dw2=0;dw2<NOMEGA;dw2++){
		
						if(dw2<=dw1){
	
							mpfr_set_d(ptmp4,0.0,GMP_RNDN);
	
							for (int dt=0;dt<TWIDTH;dt++){
				
								gslgmp_matrix_get(DCKernel,dt,dw1,ptmp1);
								gslgmp_matrix_get(DCKernel,dt,dw2,ptmp2);
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);
								gslgmp_vector_get(dwvec,dw1,ptmp1);
								gslgmp_vector_get(dwvec,dw2,ptmp2);
								mpfr_mul(ptmp3,ptmp3,ptmp1,GMP_RNDN);
								mpfr_mul(ptmp3,ptmp3,ptmp2,GMP_RNDN);

								mpfr_div(ptmp1,ptmp3,CEval->data[dt],GMP_RNDN);

								mpfr_set(ptmp2,ptmp4,GMP_RNDN);
								mpfr_sub(ptmp4,ptmp2,ptmp1,GMP_RNDN);
							}
				
							if(dw1==dw2){
	
								mpfr_ui_div(ptmp1,1,A->data[dw1],GMP_RNDN);
								gslgmp_vector_get(dwvec,dw1,ptmp2);
								mpfr_mul(ptmp1,ptmp1,ptmp2,GMP_RNDN);
								mpfr_set_d(ptmp2,alpha,GMP_RNDN);
								mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);

								mpfr_set(ptmp1,ptmp4,GMP_RNDN);
								mpfr_sub(ptmp4,ptmp1,ptmp3,GMP_RNDN);
	
							}
	
							gslgmp_matrix_set(ErrMatLoc,dw1,dw2,ptmp4);
	
						}else{
	
							gslgmp_matrix_get(ErrMatLoc,dw2,dw1,ptmp1);
							gslgmp_matrix_set(ErrMatLoc,dw1,dw2,ptmp1);
						}
		
					}}	
					
					gslgmp_vector_free(dwvec);
					gslgmp_vector_free(onevec);
					
					//*********************************************************
					//	Invert the local error matrix
					//*********************************************************
					
					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "****  INVERTING THE FULL ERRORMATRIX                 *****\n");
					fprintf(stderr, "**********************************************************\n");
					
					ErrMatInv=gslgmp_matrix_calloc(ErrMatLoc->size1,ErrMatLoc->size2);
	
					gmpQRInvert(ErrMatLoc,ErrMatInv);

					INV_test(ErrMatLoc,ErrMatInv);

					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "****  INVERTING THE FULL ERRORMATRIX     DONE!       *****\n");
					fprintf(stderr, "**********************************************************\n");
					
					for(int ecnt=0;ecnt<ERRNUM;ecnt++){
						
						//*********************************************************
						//	Average over the Error matrix to get the 
						//	variance of the current reconstructed A.
						//*********************************************************
						mpfr_set_ui(errtmp,0,GMP_RNDN);
						mpfr_set_ui(errtmp2,0,GMP_RNDN);

						if(HPNUM==0){
							

							for(int dw1=0;dw1<NOMEGA/ERRNUM;dw1++){
							for(int dw2=0;dw2<NOMEGA/ERRNUM;dw2++){

								mpfr_sub(ptmp1,omega->data[1],omega->data[0],GMP_RNDN);
								mpfr_mul(ptmp5,ptmp1,ptmp1,GMP_RNDN);
								gslgmp_matrix_get(ErrMatInv,ecnt*NOMEGA/ERRNUM+dw1,ecnt*NOMEGA/ERRNUM+dw2,ptmp1);
								mpfr_mul(ptmp1,ptmp1,ptmp5,GMP_RNDN);
								mpfr_set(ptmp2,errtmp,GMP_RNDN);
								mpfr_add(errtmp,ptmp1,ptmp2,GMP_RNDN);
	
								mpfr_add(errtmp2,errtmp2,ptmp5,GMP_RNDN);
			
							}}	

						}else{

							for(int dw1=0;dw1<NOMEGA/ERRNUM;dw1++){
								for(int dw2=0;dw2<NOMEGA/ERRNUM;dw2++){


									if(ecnt*NOMEGA/ERRNUM+dw2<OMEGAHPMIN){
									mpfr_sub(ptmp4,omega->data[ecnt*NOMEGA/ERRNUM+(dw2+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw2],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw2==OMEGAHPMIN){
									mpfr_sub(ptmp2,omega->data[OMEGAHPMIN+1],omega->data[OMEGAHPMIN],GMP_RNDN);
									mpfr_sub(ptmp3,omega->data[OMEGAHPMIN],omega->data[OMEGAHPMIN-1],GMP_RNDN);
									mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
									mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
									mpfr_add(ptmp4,ptmp2,ptmp3,GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw2>=OMEGAHPMIN+1&&ecnt*NOMEGA/ERRNUM+dw2<OMEGAHPMAX){
									mpfr_sub(ptmp4,omega->data[ecnt*NOMEGA/ERRNUM+(dw2+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw2],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw2==OMEGAHPMAX){
									mpfr_sub(ptmp2,omega->data[OMEGAHPMAX+1],omega->data[OMEGAHPMAX],GMP_RNDN);
									mpfr_sub(ptmp3,omega->data[OMEGAHPMAX],omega->data[OMEGAHPMAX-1],GMP_RNDN);
									mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
									mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
									mpfr_add(ptmp4,ptmp3,ptmp2,GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw2>OMEGAHPMAX&&ecnt*NOMEGA/ERRNUM+dw2<NOMEGA-1){
									mpfr_sub(ptmp4,omega->data[ecnt*NOMEGA/ERRNUM+(dw2+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw2],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw2==NOMEGA-1){
									mpfr_sub(ptmp4,omega->data[ecnt*NOMEGA/ERRNUM+(dw2)],omega->data[ecnt*NOMEGA/ERRNUM+(dw2-1)],GMP_RNDN);
									}


									if(ecnt*NOMEGA/ERRNUM+dw1<OMEGAHPMIN){
									mpfr_sub(ptmp5,omega->data[ecnt*NOMEGA/ERRNUM+(dw1+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw1],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw1==OMEGAHPMIN){
									mpfr_sub(ptmp2,omega->data[OMEGAHPMIN+1],omega->data[OMEGAHPMIN],GMP_RNDN);
									mpfr_sub(ptmp3,omega->data[OMEGAHPMIN],omega->data[OMEGAHPMIN-1],GMP_RNDN);
									mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
									mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
									mpfr_add(ptmp5,ptmp2,ptmp3,GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw1>=OMEGAHPMIN+1&&ecnt*NOMEGA/ERRNUM+dw1<OMEGAHPMAX){
									mpfr_sub(ptmp5,omega->data[ecnt*NOMEGA/ERRNUM+(dw1+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw1],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw1==OMEGAHPMAX){
									mpfr_sub(ptmp2,omega->data[OMEGAHPMAX+1],omega->data[OMEGAHPMAX],GMP_RNDN);
									mpfr_sub(ptmp3,omega->data[OMEGAHPMAX],omega->data[OMEGAHPMAX-1],GMP_RNDN);
									mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
									mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
									mpfr_add(ptmp5,ptmp3,ptmp2,GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw1>OMEGAHPMAX&&ecnt*NOMEGA/ERRNUM+dw1<NOMEGA-1){
									mpfr_sub(ptmp5,omega->data[ecnt*NOMEGA/ERRNUM+(dw1+1)],omega->data[ecnt*NOMEGA/ERRNUM+dw1],GMP_RNDN);
									}

									if(ecnt*NOMEGA/ERRNUM+dw1==NOMEGA-1){
									mpfr_sub(ptmp5,omega->data[ecnt*NOMEGA/ERRNUM+(dw1)],omega->data[ecnt*NOMEGA/ERRNUM+(dw1-1)],GMP_RNDN);
									}

									mpfr_mul(ptmp1,ptmp4,ptmp5,GMP_RNDN);

									mpfr_add(errtmp2,errtmp2,ptmp1,GMP_RNDN);

									gslgmp_matrix_get(ErrMatInv,ecnt*NOMEGA/ERRNUM+dw1,ecnt*NOMEGA/ERRNUM+dw2,ptmp2);
									mpfr_mul(ptmp3,ptmp1,ptmp2,GMP_RNDN);

									mpfr_add(errtmp,errtmp,ptmp3,GMP_RNDN);

								}
								
							}
						}
	
						mpfr_div(ptmp1,errtmp,errtmp2,GMP_RNDN);

						//*********************************************************
						//	SINCE THE CALCULATED QUANTITY IS THE VARIANCE OF
						//	THE RECONSTRUCTED SPECTRAL FUNCTION, TAKE THE
						//	SQUARE ROOT OF IT FOR THE ERROR.
						//*********************************************************
						
						ERRS[acnt][ecnt]=sqrt(fabs(mpfr_get_d(ptmp1,GMP_RNDN))); 

						fprintf(stderr,"ecnt:%d Errros:%e ERRS:%e \r",ecnt,-mpfr_get_d(ptmp1,GMP_RNDN),ERRS[acnt][ecnt]);


					}

					gslgmp_matrix_free(ErrMatLoc);
					gslgmp_matrix_free(ErrMatInv);

					mpfr_clear(errtmp);
					mpfr_clear(errtmp2);

