					//*********************************************************************************
					//
					//     This program is free software; you can redistribute it and/or modify
					//     it under the terms of the GNU General Public License as published by
					//     the Free Software Foundation; either version 2 of the License, or
					//     (at your option) any later version.
					//
					//     This program is distributed in the hope that it will be useful,
					//     but WITHOUT ANY WARRANTY; without even the implied warranty of
					//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
					//     GNU General Public License for more details.
					//
					//    You should have received a copy of the GNU General Public License along
					//    with this program; if not, write to the Free Software Foundation, Inc.,
					//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
					//    
					//    A copy of the GNU General Public License is also available at
					//    http://www.fsf.org/licensing/licenses
					//
					//*********************************************************************************
					
					//*********************************************************
					//	HERE WE CALCULATE LAMBDA
					//*********************************************************

					mpfr_t ptmpMUL1;
					mpfr_t ptmpMUL2;
					mpfr_t ptmpMUL3;
					mpfr_t ptmpMUL4;
					mpfr_init2(ptmpMUL1,PRECBITS);
					mpfr_init2(ptmpMUL2,PRECBITS);
					mpfr_init2(ptmpMUL3,PRECBITS);
					mpfr_init2(ptmpMUL4,PRECBITS);
		
					Lambda=gslgmp_matrix_calloc(NOMEGA,NOMEGA);
			
					for(int i=0; i<NOMEGA;i++){
					for(int j=0; j<NOMEGA;j++){

						mpfr_set_ui(ptmpMUL4,0,GMP_RNDN);

						for(int k=0;k<TWIDTH;k++){

							gslgmp_matrix_get(DCKernel,k,j,ptmpMUL1);
							gslgmp_matrix_get(DCKernel,k,i,ptmpMUL2);

							mpfr_mul(ptmpMUL3,ptmpMUL1,ptmpMUL2,GMP_RNDN);

							gslgmp_vector_get(CEval,k,ptmpMUL1);

							mpfr_div(ptmpMUL2,ptmpMUL3,ptmpMUL1,GMP_RNDN);
						
							mpfr_add(ptmpMUL4,ptmpMUL4,ptmpMUL2,GMP_RNDN);
						
						}


						mpfr_sqrt(ptmpMUL1,Adw->data[i],GMP_RNDN);
						mpfr_sqrt(ptmpMUL2,Adw->data[j],GMP_RNDN);

						mpfr_mul(ptmpMUL3,ptmpMUL1,ptmpMUL2,GMP_RNDN);

						mpfr_mul(ptmpMUL1,ptmpMUL3,ptmpMUL4,GMP_RNDN);
	
						gslgmp_matrix_set(Lambda,i,j,ptmpMUL1);

					}}
		
					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "**** LAMBDA MATRIX CREATED SUCCESFULLY   A: %4d  ********\n",acnt);
					fprintf(stderr, "**********************************************************\n");

					//*********************************************************
					//	Calculate Eigenvalues of Lambda
					//*********************************************************
				
					LEvec=gslgmp_matrix_calloc(Lambda->size1,Lambda->size2);
					LEval=gslgmp_vector_calloc(Lambda->size1);
				
					double EigTST;
				
					gmpEigenSYS_SYMM(Lambda,LEvec,LEval);
		
					EiV_test(Lambda,LEvec,LEval,&EigTST);
		
					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "**** LAMBDA MATRIX EIGENVALUES CALC'ED   A: %4d  ********\n",acnt);
					fprintf(stderr, "**********************************************************\n");

					//*********************************************************
					//	Since Lambda is susceptible for leaving the
					//	range of precision check if NAN or inf
					//*********************************************************
				
					for (int i=0;i<NOMEGA;i++){
				
						mpfr_set(ptmp1,LEval->data[i],GMP_RNDN);
						if(mpfr_nan_p(ptmp1)!=0||mpfr_inf_p(ptmp1)!=0) {fprintf(stderr,"Inf/Nan encountered in Eigenvalue calculation:%e\n",mpfr_get_d(ptmp1,GMP_RNDN)); mpfr_set_d(ptmp1,0.,GMP_RNDN);};
						gslgmp_vector_set(LEval,i,ptmp1);
					}
					
					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "**** EIGENVALUES OF THE LAMBDA MATRIX             ********\n");
					fprintf(stderr, "**********************************************************\n");
					
					gmpPVec(LEval);
		
					//*********************************************************
					//	Calculate the argument of the exponential in the 
					//	Probability formula (3.19) for the current alpha
					//	0.5*Sum_k Log[alpha/(alpha+lambda_k)]+alpha*S-L
					//*********************************************************


					//*********************************************************
					//	FROM NICKEL: PROBABILITY TERM HAS THE FORM:
					//
					//	SUM_i Log[ ALPHA*DW/(ALPHA*DW+LAMBDA_i) ]
					//*********************************************************
		
					mpfr_t asum;
					mpfr_init2(asum,PRECBITS);
					mpfr_set_ui(asum,0,GMP_RNDN);
					
					for(int dw=0;dw<NOMEGA;dw++){
				
						
						if(HPNUM==0){
							
							mpfr_sub(ptmp1,omega->data[1],omega->data[0],GMP_RNDN);
						
						}else{
						
							if(dw<OMEGAHPMIN) mpfr_sub(ptmp1,omega->data[1],omega->data[0],GMP_RNDN);
							if(dw==OMEGAHPMIN) {		
										mpfr_sub(ptmp3,omega->data[OMEGAHPMIN+1],omega->data[OMEGAHPMIN],GMP_RNDN);
										mpfr_sub(ptmp2,omega->data[OMEGAHPMIN],omega->data[OMEGAHPMIN-1],GMP_RNDN);
										mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
										mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
										mpfr_add(ptmp1,ptmp3,ptmp2,GMP_RNDN);
									    }
							if(OMEGAHPMIN<dw&&dw<OMEGAHPMAX) mpfr_sub(ptmp1,omega->data[OMEGAHPMIN+2],omega->data[OMEGAHPMIN+1],GMP_RNDN);
									    
							if(dw==OMEGAHPMAX) {		
										mpfr_sub(ptmp3,omega->data[OMEGAHPMAX+1],omega->data[OMEGAHPMAX],GMP_RNDN);
										mpfr_sub(ptmp2,omega->data[OMEGAHPMAX],omega->data[OMEGAHPMAX-1],GMP_RNDN);
										mpfr_div_ui(ptmp3,ptmp3,2,GMP_RNDN);
										mpfr_div_ui(ptmp2,ptmp2,2,GMP_RNDN);
										mpfr_add(ptmp1,ptmp3,ptmp2,GMP_RNDN);
									    }
									    
							if(OMEGAHPMAX<dw) mpfr_sub(ptmp1,omega->data[OMEGAHPMAX+2],omega->data[OMEGAHPMAX+1],GMP_RNDN);
									
						}
						
						mpfr_set_d(ptmp2,alpha,GMP_RNDN);
						mpfr_mul(ptmp1,ptmp1,ptmp2,GMP_RNDN);

						mpfr_add(ptmp2,ptmp1,LEval->data[dw],GMP_RNDN);
						mpfr_div(ptmp3,ptmp1,ptmp2,GMP_RNDN);
						mpfr_log(ptmp1,ptmp3,GMP_RNDN);
				
						mpfr_div_ui(ptmp1,ptmp1,2,GMP_RNDN);
						mpfr_add(asum,asum,ptmp1,GMP_RNDN);
					}

	
					if(acnt<ANUM) { 
						
						mpfr_mul_d(ptmp1,Sval,alpha,GMP_RNDN);
						mpfr_sub(ptmp1,ptmp1,Lval,GMP_RNDN);
						mpfr_add(ptmp1,ptmp1,asum,GMP_RNDN);
						mpfr_set(LOGPROB->data[acnt],ptmp1,GMP_RNDN);
						
						}
		
					fprintf(stderr, "**********************************************************\n");
					fprintf(stderr, "**** ASUM %.5e LOGPROB %.5e              ********\n",mpfr_get_d(asum,GMP_RNDN),mpfr_get_d(LOGPROB->data[acnt],GMP_RNDN));
					fprintf(stderr, "**********************************************************\n");
					
					gslgmp_matrix_free(Lambda);
					gslgmp_vector_free(LEval);
					gslgmp_matrix_free(LEvec);

					mpfr_clear(asum);
					mpfr_clear(ptmpMUL1);
					mpfr_clear(ptmpMUL2);
					mpfr_clear(ptmpMUL3);
					mpfr_clear(ptmpMUL4);
