//*********************************************************************************
//
//     This program is free software; you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation; either version 2 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//    
//    A copy of the GNU General Public License is also available at
//    http://www.fsf.org/licensing/licenses
//
//*********************************************************************************

//*********************************************************************************
//	The routines that provide a platform indepoendent GUI for the 
//	use of the MEM program based on the wxWidget library.
//*********************************************************************************

	//*********************************************************************************
	//	The constructor for the credits dialog comes here needs to be filled
	//	Also the test routines for the SVD and EIGENSYSTEM need to be added
	//*********************************************************************************

	MyCredits::MyCredits(const wxString& title) : wxFrame(NULL, wxID_ANY, title, wxDefaultPosition, wxSize(600, 300))
	{
		this->SetSizeHints( wxDefaultSize, wxDefaultSize );
		
		wxBoxSizer* bSizer2;
		bSizer2 = new wxBoxSizer( wxVERTICAL );
		
		m_notebook1 = new wxNotebook( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, 0 );
		m_panel1 = new wxPanel( m_notebook1, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer3;
		bSizer3 = new wxBoxSizer( wxVERTICAL );
		
		m_textCtrl1 = new wxTextCtrl( m_panel1, wxID_ANY, wxT("Copyright (C) 2011  Dr. Alexander Rothkopf\n\nThis program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation; either version 2 of the License, or\n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License along\nwith this program; if not, write to the Free Software Foundation, Inc.,\n51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.\n\nA copy of the GNU General Public License is also available at\nhttp://www.fsf.org/licensing/licenses\n\n\nSource Code available at: www.scicode.org/ExtMEM"), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY  );
		bSizer3->Add( m_textCtrl1, 1, wxALL|wxEXPAND, 5 );		
		
		m_panel1->SetSizer( bSizer3 );
		m_panel1->Layout();
		bSizer3->Fit( m_panel1 );
		m_notebook1->AddPage( m_panel1, wxT("License and Legal Info"), true );
		m_panel2 = new wxPanel( m_notebook1, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer4;
		bSizer4 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer5;
		bSizer5 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button2 = new wxButton( m_panel2, wxID_ANY, wxT("HighPrec Variables"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer5->Add( m_button2, 0, wxALL, 5 );
		
		m_button3 = new wxButton( m_panel2, wxID_ANY, wxT("SVD"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer5->Add( m_button3, 0, wxALL, 5 );
		
		m_button4 = new wxButton( m_panel2, wxID_ANY, wxT("Eigensystems"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer5->Add( m_button4, 0, wxALL, 5 );
		
		bSizer4->Add( bSizer5, 0, wxEXPAND, 5 );
		
		m_textCtrl2 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("Not yet implemented"), wxDefaultPosition, wxSize( -1,100 ), 0 );
		bSizer4->Add( m_textCtrl2, 1, wxALL|wxEXPAND, 5 );
		
		m_panel2->SetSizer( bSizer4 );
		m_panel2->Layout();
		bSizer4->Fit( m_panel2 );
		m_notebook1->AddPage( m_panel2, wxT("Testing Routines"), false );
		m_panel3 = new wxPanel( m_notebook1, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer6;
		bSizer6 = new wxBoxSizer( wxVERTICAL );
		
		m_textCtrl3 = new wxTextCtrl( m_panel3, wxID_ANY, wxT(	"TITLE: ExtMEM\n\nTHIS PROGRAM IS AN IMPLEMENTATION OF THE MAXIMUM ENTROPY METHOD\nFOR THE NUMERICAL INVERSION OF THE TYPICALLY ILL DEFINED TASK\n\nDATA[t] = Int_-inf^inf [ K[w,t] * SPEC[w] ]dw\n\nWHERE THE GOAL IS TO EXTRACT THE SPECTRAL FUNCTION SPEC[w] FROM\nTHE PROVIDED LATTICE DATA DATA[t] USING A PREVIOUSLY SPECIFIED\nKERNEL FUNCTION K[w,t].\n\n	AUTHOR: Dr. Alexander Karl Rothkopf	DATE: November 6th 2011\n\nReference:\n\nImproved Maximum Entropy Analysis with an Extended Search Space\nA.Rothkopf (Bielefeld. U)\ne-Print: arXiv:1110.6285\nUrl: http://arxiv.org/abs/arXiv:1110.6285\n\nI AM GRATEFUL FOR THE HELPFUL COMMENTS FROM T.HATSUDA, S.SASAKI, \nK. SASAKI, O. KACZMAREK AND H.T. DING"), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY );
		bSizer6->Add( m_textCtrl3, 1, wxALL|wxEXPAND, 5 );
	
	
		
		
		m_panel3->SetSizer( bSizer6 );
		m_panel3->Layout();
		bSizer6->Fit( m_panel3 );
		m_notebook1->AddPage( m_panel3, wxT("Misc."), false );
		
		bSizer2->Add( m_notebook1, 1, wxEXPAND | wxALL, 5 );
		
		this->SetSizer( bSizer2 );
		this->Layout();
	}



	//*********************************************************************************
	//	The Menu constructor that actually places the individual elements on the
	//	screen and initializes their default values.
	//*********************************************************************************

MenuBase::MenuBase(const wxString& title): wxFrame(NULL, wxID_ANY, title, wxDefaultPosition, wxSize(-1, -1))
{

	if(wxSystemSettings::GetMetric(wxSYS_SCREEN_Y)>1000){
	
		this->SetSizeHints( wxDefaultSize, wxDefaultSize );
		this ->SetFont( wxFont( -1, 74, 90, 92, false, wxT("Sans") ) );
		
		wxBoxSizer* bSizer1;
		bSizer1 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer2;
		bSizer2 = new wxBoxSizer( wxHORIZONTAL );
		
		wxBoxSizer* bSizer5;
		bSizer5 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer1;
		sbSizer1 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Global Precision of the MEM") ), wxVERTICAL );
		
		wxBoxSizer* bSizer12;
		bSizer12 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText1 = new wxStaticText( this, wxID_ANY, wxT("Precision Bits:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText1->Wrap( -1 );
		bSizer12->Add( m_staticText1, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl1 = new wxTextCtrl( this, wxID_ANY, wxT("384"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl1->SetFont( wxFont( -1, 74, 90, 92, false, wxT("Sans") ) );
		
		bSizer12->Add( m_textCtrl1, 1, wxALL, 5 );
		
		sbSizer1->Add( bSizer12, 1, wxEXPAND, 5 );
		
		bSizer5->Add( sbSizer1, 0, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer2;
		sbSizer2 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("I/O Folders and Files") ), wxVERTICAL );
		
		wxBoxSizer* bSizer13;
		bSizer13 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer14;
		bSizer14 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button1 = new wxButton( this, wxID_ANY, wxT("DataFolder"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button1->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer14->Add( m_button1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl2 = new wxTextCtrl( this, wxID_ANY, wxT("./data"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl2->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer14->Add( m_textCtrl2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer14, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer15;
		bSizer15 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button2 = new wxButton( this, wxID_ANY, wxT("Filename"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button2->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer15->Add( m_button2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl3 = new wxTextCtrl( this, wxID_ANY, wxT("wilson_conf"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl3->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer15->Add( m_textCtrl3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer15, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer17;
		bSizer17 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText2 = new wxStaticText( this, wxID_ANY, wxT("FileFormat:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText2->Wrap( -1 );
		m_staticText2->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer17->Add( m_staticText2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice1Choices[] = { wxT("multifile WL"), wxT("singlefile WL") };
		int m_choice1NChoices = sizeof( m_choice1Choices ) / sizeof( wxString );
		m_choice1 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxSize( -1,-1 ), m_choice1NChoices, m_choice1Choices, 0 );
		m_choice1->SetSelection( 0 );
		m_choice1->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer17->Add( m_choice1, 1, wxALL, 5 );
		
		bSizer13->Add( bSizer17, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer19;
		bSizer19 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText3 = new wxStaticText( this, wxID_ANY, wxT("# of Meas. (Nconf):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText3->Wrap( -1 );
		m_staticText3->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer19->Add( m_staticText3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl5 = new wxTextCtrl( this, wxID_ANY, wxT("600"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl5->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer19->Add( m_textCtrl5, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer19, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer21;
		bSizer21 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText4 = new wxStaticText( this, wxID_ANY, wxT("Start with #:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText4->Wrap( -1 );
		m_staticText4->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer21->Add( m_staticText4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl6 = new wxTextCtrl( this, wxID_ANY, wxT("500"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl6->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer21->Add( m_textCtrl6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer21, 0, wxEXPAND, 5 );
		
		m_staticline1 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer13->Add( m_staticline1, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer22;
		bSizer22 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText5 = new wxStaticText( this, wxID_ANY, wxT("# of Datasets (Nx)"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText5->Wrap( -1 );
		m_staticText5->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer22->Add( m_staticText5, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl7 = new wxTextCtrl( this, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl7->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer22->Add( m_textCtrl7, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer22, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer23;
		bSizer23 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText6 = new wxStaticText( this, wxID_ANY, wxT("Start with set [0...Nx-1]:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText6->Wrap( -1 );
		m_staticText6->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer23->Add( m_staticText6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl8 = new wxTextCtrl( this, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl8->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer23->Add( m_textCtrl8, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer23, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer24;
		bSizer24 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText7 = new wxStaticText( this, wxID_ANY, wxT("End with set:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText7->Wrap( -1 );
		m_staticText7->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer24->Add( m_staticText7, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl9 = new wxTextCtrl( this, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl9->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer24->Add( m_textCtrl9, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer24, 1, wxEXPAND, 5 );
		
		m_staticline6 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer13->Add( m_staticline6, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer16;
		bSizer16 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button3 = new wxButton( this, wxID_ANY, wxT("ResultsFolder"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button3->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer16->Add( m_button3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl4 = new wxTextCtrl( this, wxID_ANY, wxT("./results"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl4->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer16->Add( m_textCtrl4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer16, 0, wxEXPAND, 5 );
		
		sbSizer2->Add( bSizer13, 1, wxEXPAND, 5 );
		
		bSizer5->Add( sbSizer2, 1, wxEXPAND, 5 );
		
		bSizer2->Add( bSizer5, 1, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer3;
		sbSizer3 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Tau and Omega range") ), wxVERTICAL );
		
		wxBoxSizer* bSizer25;
		bSizer25 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText9 = new wxStaticText( this, wxID_ANY, wxT("# of axis points (Nt):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText9->Wrap( -1 );
		m_staticText9->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer25->Add( m_staticText9, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl11 = new wxTextCtrl( this, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl11->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer25->Add( m_textCtrl11, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer25, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer26;
		bSizer26 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText10 = new wxStaticText( this, wxID_ANY, wxT("#of stored points:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText10->Wrap( -1 );
		m_staticText10->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer26->Add( m_staticText10, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl12 = new wxTextCtrl( this, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl12->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer26->Add( m_textCtrl12, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer26, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer27;
		bSizer27 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText11 = new wxStaticText( this, wxID_ANY, wxT("Start from t [1...Nt] (tmin):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText11->Wrap( -1 );
		m_staticText11->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer27->Add( m_staticText11, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl13 = new wxTextCtrl( this, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl13->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer27->Add( m_textCtrl13, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer27, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer28;
		bSizer28 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText12 = new wxStaticText( this, wxID_ANY, wxT("End with t [tmin+1...Nt]:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText12->Wrap( -1 );
		m_staticText12->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer28->Add( m_staticText12, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl14 = new wxTextCtrl( this, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl14->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer28->Add( m_textCtrl14, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer28, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer29;
		bSizer29 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText13 = new wxStaticText( this, wxID_ANY, wxT("Value at tmax (beta):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText13->Wrap( -1 );
		m_staticText13->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer29->Add( m_staticText13, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl15 = new wxTextCtrl( this, wxID_ANY, wxT("6.1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl15->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer29->Add( m_textCtrl15, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer29, 1, wxEXPAND, 5 );
		
		m_staticline2 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		sbSizer3->Add( m_staticline2, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer30;
		bSizer30 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText14 = new wxStaticText( this, wxID_ANY, wxT("# of frequency points:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText14->Wrap( -1 );
		m_staticText14->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer30->Add( m_staticText14, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl16 = new wxTextCtrl( this, wxID_ANY, wxT("1500"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl16->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer30->Add( m_textCtrl16, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer30, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer31;
		bSizer31 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText15 = new wxStaticText( this, wxID_ANY, wxT("w_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText15->Wrap( -1 );
		m_staticText15->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer31->Add( m_staticText15, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl17 = new wxTextCtrl( this, wxID_ANY, wxT("-10."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl17->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer31->Add( m_textCtrl17, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer31, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer32;
		bSizer32 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText16 = new wxStaticText( this, wxID_ANY, wxT("w_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText16->Wrap( -1 );
		m_staticText16->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer32->Add( m_staticText16, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl18 = new wxTextCtrl( this, wxID_ANY, wxT("20."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl18->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer32->Add( m_textCtrl18, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer32, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer33;
		bSizer33 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText17 = new wxStaticText( this, wxID_ANY, wxT("Extra Interval (HPNum):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText17->Wrap( -1 );
		m_staticText17->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer33->Add( m_staticText17, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl19 = new wxTextCtrl( this, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl19->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer33->Add( m_textCtrl19, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer33, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer34;
		bSizer34 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText18 = new wxStaticText( this, wxID_ANY, wxT("wHP_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText18->Wrap( -1 );
		m_staticText18->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer34->Add( m_staticText18, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl20 = new wxTextCtrl( this, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl20->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer34->Add( m_textCtrl20, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer34, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer35;
		bSizer35 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText19 = new wxStaticText( this, wxID_ANY, wxT("wHP_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText19->Wrap( -1 );
		m_staticText19->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer35->Add( m_staticText19, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl21 = new wxTextCtrl( this, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl21->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer35->Add( m_textCtrl21, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer35, 1, wxEXPAND, 5 );
		
		bSizer2->Add( sbSizer3, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer8;
		bSizer8 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer4;
		sbSizer4 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Kernel and Prior") ), wxVERTICAL );
		
		wxBoxSizer* bSizer36;
		bSizer36 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer37;
		bSizer37 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText20 = new wxStaticText( this, wxID_ANY, wxT("Kernel Type:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText20->Wrap( -1 );
		m_staticText20->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer37->Add( m_staticText20, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice2Choices[] = { wxT("exp(-wt)"), wxT("finite T exp()") };
		int m_choice2NChoices = sizeof( m_choice2Choices ) / sizeof( wxString );
		m_choice2 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice2NChoices, m_choice2Choices, 0 );
		m_choice2->SetSelection( 0 );
		m_choice2->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer37->Add( m_choice2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer37, 1, wxEXPAND, 5 );
		
		m_staticline3 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer36->Add( m_staticline3, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer38;
		bSizer38 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText21 = new wxStaticText( this, wxID_ANY, wxT("Prior Form:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText21->Wrap( -1 );
		m_staticText21->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer38->Add( m_staticText21, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice3Choices[] = { wxT("1/(w-w_0)"), wxT("w^(option)"), wxT("const") };
		int m_choice3NChoices = sizeof( m_choice3Choices ) / sizeof( wxString );
		m_choice3 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice3NChoices, m_choice3Choices, 0 );
		m_choice3->SetSelection( 0 );
		m_choice3->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer38->Add( m_choice3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer38, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer39;
		bSizer39 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText22 = new wxStaticText( this, wxID_ANY, wxT("Prior Amplitude:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText22->Wrap( -1 );
		m_staticText22->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer39->Add( m_staticText22, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl22 = new wxTextCtrl( this, wxID_ANY, wxT("0.01"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl22->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer39->Add( m_textCtrl22, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer39, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer40;
		bSizer40 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText23 = new wxStaticText( this, wxID_ANY, wxT("Prior Option:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText23->Wrap( -1 );
		m_staticText23->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer40->Add( m_staticText23, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl23 = new wxTextCtrl( this, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl23->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer40->Add( m_textCtrl23, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer40, 1, wxEXPAND, 5 );
		
		sbSizer4->Add( bSizer36, 1, wxEXPAND, 5 );
		
		bSizer8->Add( sbSizer4, 1, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer5;
		sbSizer5 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Alpha steps") ), wxVERTICAL );
		
		wxBoxSizer* bSizer42;
		bSizer42 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText24 = new wxStaticText( this, wxID_ANY, wxT("Precondition alpha:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText24->Wrap( -1 );
		m_staticText24->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer42->Add( m_staticText24, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl24 = new wxTextCtrl( this, wxID_ANY, wxT("5.0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl24->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer42->Add( m_textCtrl24, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer42, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer43;
		bSizer43 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText25 = new wxStaticText( this, wxID_ANY, wxT("Alpha steps:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText25->Wrap( -1 );
		m_staticText25->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer43->Add( m_staticText25, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl25 = new wxTextCtrl( this, wxID_ANY, wxT("50"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl25->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer43->Add( m_textCtrl25, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer43, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer44;
		bSizer44 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText26 = new wxStaticText( this, wxID_ANY, wxT("alpha_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText26->Wrap( -1 );
		m_staticText26->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer44->Add( m_staticText26, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl26 = new wxTextCtrl( this, wxID_ANY, wxT("4.0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl26->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer44->Add( m_textCtrl26, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer44, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer45;
		bSizer45 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText27 = new wxStaticText( this, wxID_ANY, wxT("alpha_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText27->Wrap( -1 );
		m_staticText27->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer45->Add( m_staticText27, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl27 = new wxTextCtrl( this, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl27->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer45->Add( m_textCtrl27, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer45, 1, wxEXPAND, 5 );
		
		bSizer8->Add( sbSizer5, 1, wxEXPAND, 5 );
		
		bSizer2->Add( bSizer8, 1, wxEXPAND, 5 );
		
		bSizer1->Add( bSizer2, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer3;
		bSizer3 = new wxBoxSizer( wxHORIZONTAL );
		
		wxBoxSizer* bSizer9;
		bSizer9 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer6;
		sbSizer6 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Minimizer") ), wxVERTICAL );
		
		wxBoxSizer* bSizer46;
		bSizer46 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText28 = new wxStaticText( this, wxID_ANY, wxT("Algorithm:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText28->Wrap( -1 );
		m_staticText28->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_staticText28, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice4Choices[] = { wxT("LM prec. SVD (EXT)"), wxT("LM prec. SVD"), wxT("LBFGS SVD"), wxT("LBFGS FULL OMEGA") };
		int m_choice4NChoices = sizeof( m_choice4Choices ) / sizeof( wxString );
		m_choice4 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice4NChoices, m_choice4Choices, 0 );
		m_choice4->SetSelection( 0 );
		m_choice4->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_choice4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_staticText35 = new wxStaticText( this, wxID_ANY, wxT("use:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText35->Wrap( -1 );
		m_staticText35->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_staticText35, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice6Choices[] = { wxT("Q(L,S)"), wxT("L"), wxT("S") };
		int m_choice6NChoices = sizeof( m_choice6Choices ) / sizeof( wxString );
		m_choice6 = new wxChoice( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice6NChoices, m_choice6Choices, 0 );
		m_choice6->SetSelection( 0 );
		m_choice6->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_choice6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer46, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer47;
		bSizer47 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText29 = new wxStaticText( this, wxID_ANY, wxT("ExtendSVD by:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText29->Wrap( -1 );
		m_staticText29->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_staticText29, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl28 = new wxTextCtrl( this, wxID_ANY, wxT("12"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl28->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_textCtrl28, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_staticText36 = new wxStaticText( this, wxID_ANY, wxT("LBFGS #:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText36->Wrap( -1 );
		m_staticText36->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_staticText36, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl35 = new wxTextCtrl( this, wxID_ANY, wxT("200"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl35->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_textCtrl35, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer47, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer48;
		bSizer48 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText31 = new wxStaticText( this, wxID_ANY, wxT("Tolerance (prec./norm.):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText31->Wrap( -1 );
		m_staticText31->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer48->Add( m_staticText31, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxBoxSizer* bSizer57;
		bSizer57 = new wxBoxSizer( wxHORIZONTAL );
		
		m_textCtrl30 = new wxTextCtrl( this, wxID_ANY, wxT("1e-20"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl30->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer57->Add( m_textCtrl30, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl31 = new wxTextCtrl( this, wxID_ANY, wxT("1e-10"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl31->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer57->Add( m_textCtrl31, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer48->Add( bSizer57, 1, wxEXPAND, 5 );
		
		sbSizer6->Add( bSizer48, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer49;
		bSizer49 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText32 = new wxStaticText( this, wxID_ANY, wxT("Max Iterations:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText32->Wrap( -1 );
		m_staticText32->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_staticText32, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl32 = new wxTextCtrl( this, wxID_ANY, wxT("100000"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl32->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_textCtrl32, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_checkBox1 = new wxCheckBox( this, wxID_ANY, wxT("ChkSubsp.:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_checkBox1->SetValue(true); 
		m_checkBox1->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_checkBox1, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl34 = new wxTextCtrl( this, wxID_ANY, wxT("200"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl34->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_textCtrl34, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer49, 1, wxEXPAND, 5 );
		
		m_staticline4 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		sbSizer6->Add( m_staticline4, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer52;
		bSizer52 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText37 = new wxStaticText( this, wxID_ANY, wxT("# of Error Intervals:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText37->Wrap( -1 );
		m_staticText37->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_staticText37, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl36 = new wxTextCtrl( this, wxID_ANY, wxT("100"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl36->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_textCtrl36, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_checkBox2 = new wxCheckBox( this, wxID_ANY, wxT("Full Error Matrix"), wxDefaultPosition, wxDefaultSize, 0 );
		m_checkBox2->SetValue(true); 
		m_checkBox2->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_checkBox2, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer52, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer53;
		bSizer53 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText38 = new wxStaticText( this, wxID_ANY, wxT("# of Jacknife Intervals:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText38->Wrap( -1 );
		m_staticText38->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer53->Add( m_staticText38, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl37 = new wxTextCtrl( this, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl37->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer53->Add( m_textCtrl37, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer53, 1, wxEXPAND, 5 );
		
		bSizer9->Add( sbSizer6, 1, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer7;
		sbSizer7 = new wxStaticBoxSizer( new wxStaticBox( this, wxID_ANY, wxT("Mock options") ), wxVERTICAL );
		
		wxBoxSizer* bSizer54;
		bSizer54 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText39 = new wxStaticText( this, wxID_ANY, wxT("Mock Data generation:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText39->Wrap( -1 );
		m_staticText39->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer54->Add( m_staticText39, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl38 = new wxTextCtrl( this, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl38->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer54->Add( m_textCtrl38, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer54, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer55;
		bSizer55 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText40 = new wxStaticText( this, wxID_ANY, wxT("Mock Noise ampl.:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText40->Wrap( -1 );
		m_staticText40->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer55->Add( m_staticText40, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl39 = new wxTextCtrl( this, wxID_ANY, wxT("0.001"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl39->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer55->Add( m_textCtrl39, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer55, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer56;
		bSizer56 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText41 = new wxStaticText( this, wxID_ANY, wxT("Mock option:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText41->Wrap( -1 );
		m_staticText41->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer56->Add( m_staticText41, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl40 = new wxTextCtrl( this, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl40->SetFont( wxFont( -1, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer56->Add( m_textCtrl40, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer56, 1, wxEXPAND, 5 );
		
		bSizer9->Add( sbSizer7, 0, wxEXPAND, 5 );
		
		bSizer3->Add( bSizer9, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer11;
		bSizer11 = new wxBoxSizer( wxVERTICAL );
		
		m_notebookTHREAD = new wxNotebook( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, 0 );
		m_panel4 = new wxPanel( m_notebookTHREAD, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer59;
		bSizer59 = new wxBoxSizer( wxVERTICAL );
		
		m_textCtrl41 = new wxTextCtrl( m_panel4, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY );
		bSizer59->Add( m_textCtrl41, 1, wxALL|wxEXPAND, 5 );
		
		m_gauge1 = new wxGauge( m_panel4, wxID_ANY, 100, wxDefaultPosition, wxDefaultSize, wxGA_HORIZONTAL );
		bSizer59->Add( m_gauge1, 0, wxALL|wxEXPAND, 5 );
		
		m_panel4->SetSizer( bSizer59 );
		m_panel4->Layout();
		bSizer59->Fit( m_panel4 );
		m_notebookTHREAD->AddPage( m_panel4, wxT("Start New MEM"), false );
		
		bSizer11->Add( m_notebookTHREAD, 1, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer58;
		bSizer58 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button4 = new wxButton( this, wxID_ANY, wxT("Credits and Legal Info"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button4, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		
		bSizer58->Add( 0, 0, 1, wxEXPAND, 5 );
		
		m_button5 = new wxButton( this, wxID_ANY, wxT("Save Config"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button5, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_button6 = new wxButton( this, wxID_ANY, wxT("Load Config"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button6, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		
		bSizer58->Add( 0, 0, 1, wxEXPAND, 5 );
		
		m_button7 = new wxButton( this, wxID_ANY, wxT("Run MEM"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button7->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
		m_button7->SetMinSize( wxSize( -1,45 ) );
		
		bSizer58->Add( m_button7, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer11->Add( bSizer58, 0, wxEXPAND, 5 );
		
		bSizer3->Add( bSizer11, 2, wxEXPAND, 5 );
		
		bSizer1->Add( bSizer3, 1, wxEXPAND, 5 );
		
		this->SetSizer( bSizer1 );
		this->Layout();
		bSizer1->Fit( this );
	
	}else{
	
		this->SetSizeHints( wxDefaultSize, wxDefaultSize );
		this ->SetFont( wxFont( -1, 74, 90, 92, false, wxT("Sans") ) );

		wxBoxSizer* bSizer1;
		bSizer1 = new wxBoxSizer( wxHORIZONTAL );
		
		m_notebook21 = new wxNotebook( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, 0 );
		m_panel2 = new wxPanel( m_notebook21, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer5;
		bSizer5 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer1;
		sbSizer1 = new wxStaticBoxSizer( new wxStaticBox( m_panel2, wxID_ANY, wxT("Global Precision of the MEM") ), wxVERTICAL );
		
		wxBoxSizer* bSizer12;
		bSizer12 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText1 = new wxStaticText( m_panel2, wxID_ANY, wxT("Precision Bits:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText1->Wrap( -1 );
		bSizer12->Add( m_staticText1, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl1 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("384"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl1->SetFont( wxFont( 10, 74, 90, 92, false, wxT("Sans") ) );
		
		bSizer12->Add( m_textCtrl1, 1, wxALL, 5 );
		
		sbSizer1->Add( bSizer12, 1, wxEXPAND, 5 );
		
		bSizer5->Add( sbSizer1, 0, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer2;
		sbSizer2 = new wxStaticBoxSizer( new wxStaticBox( m_panel2, wxID_ANY, wxT("I/O Folders and Files") ), wxVERTICAL );
		
		wxBoxSizer* bSizer13;
		bSizer13 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer14;
		bSizer14 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button1 = new wxButton( m_panel2, wxID_ANY, wxT("DataFolder"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button1->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer14->Add( m_button1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl2 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("./data"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl2->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer14->Add( m_textCtrl2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer14, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer15;
		bSizer15 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button2 = new wxButton( m_panel2, wxID_ANY, wxT("Filename"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button2->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer15->Add( m_button2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl3 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("wilson_conf"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl3->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer15->Add( m_textCtrl3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer15, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer17;
		bSizer17 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText2 = new wxStaticText( m_panel2, wxID_ANY, wxT("FileFormat:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText2->Wrap( -1 );
		m_staticText2->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer17->Add( m_staticText2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice1Choices[] = { wxT("multifile WL"), wxT("singlefile WL") };
		int m_choice1NChoices = sizeof( m_choice1Choices ) / sizeof( wxString );
		m_choice1 = new wxChoice( m_panel2, wxID_ANY, wxDefaultPosition, wxSize( -1,-1 ), m_choice1NChoices, m_choice1Choices, 0 );
		m_choice1->SetSelection( 0 );
		m_choice1->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer17->Add( m_choice1, 1, wxALL, 5 );
		
		bSizer13->Add( bSizer17, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer19;
		bSizer19 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText3 = new wxStaticText( m_panel2, wxID_ANY, wxT("# of Meas. (Nconf):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText3->Wrap( -1 );
		m_staticText3->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer19->Add( m_staticText3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl5 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("600"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl5->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer19->Add( m_textCtrl5, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer19, 0, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer21;
		bSizer21 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText4 = new wxStaticText( m_panel2, wxID_ANY, wxT("Start with #:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText4->Wrap( -1 );
		m_staticText4->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer21->Add( m_staticText4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl6 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("500"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl6->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer21->Add( m_textCtrl6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer21, 0, wxEXPAND, 5 );
		
		m_staticline1 = new wxStaticLine( m_panel2, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer13->Add( m_staticline1, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer22;
		bSizer22 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText5 = new wxStaticText( m_panel2, wxID_ANY, wxT("# of Datasets (Nx)"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText5->Wrap( -1 );
		m_staticText5->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer22->Add( m_staticText5, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl7 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl7->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer22->Add( m_textCtrl7, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer22, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer23;
		bSizer23 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText6 = new wxStaticText( m_panel2, wxID_ANY, wxT("Start with set:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText6->Wrap( -1 );
		m_staticText6->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer23->Add( m_staticText6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl8 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl8->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer23->Add( m_textCtrl8, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer23, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer24;
		bSizer24 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText7 = new wxStaticText( m_panel2, wxID_ANY, wxT("End with set:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText7->Wrap( -1 );
		m_staticText7->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer24->Add( m_staticText7, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl9 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl9->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer24->Add( m_textCtrl9, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer24, 1, wxEXPAND, 5 );
		
		m_staticline6 = new wxStaticLine( m_panel2, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer13->Add( m_staticline6, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer16;
		bSizer16 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button3 = new wxButton( m_panel2, wxID_ANY, wxT("ResultsFolder"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button3->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer16->Add( m_button3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl4 = new wxTextCtrl( m_panel2, wxID_ANY, wxT("./results"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl4->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer16->Add( m_textCtrl4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer13->Add( bSizer16, 0, wxEXPAND, 5 );
		
		sbSizer2->Add( bSizer13, 1, wxEXPAND, 5 );
		
		bSizer5->Add( sbSizer2, 1, wxEXPAND, 5 );
		
		m_panel2->SetSizer( bSizer5 );
		m_panel2->Layout();
		bSizer5->Fit( m_panel2 );
		m_notebook21->AddPage( m_panel2, wxT("Precision and I/O"), true );
		m_panel3 = new wxPanel( m_notebook21, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxStaticBoxSizer* sbSizer3;
		sbSizer3 = new wxStaticBoxSizer( new wxStaticBox( m_panel3, wxID_ANY, wxT("Tau and Omega range") ), wxVERTICAL );
		
		wxBoxSizer* bSizer25;
		bSizer25 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText9 = new wxStaticText( m_panel3, wxID_ANY, wxT("# of axis points (Nt):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText9->Wrap( -1 );
		m_staticText9->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer25->Add( m_staticText9, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl11 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl11->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer25->Add( m_textCtrl11, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer25, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer26;
		bSizer26 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText10 = new wxStaticText( m_panel3, wxID_ANY, wxT("#of stored points:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText10->Wrap( -1 );
		m_staticText10->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer26->Add( m_staticText10, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl12 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl12->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer26->Add( m_textCtrl12, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer26, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer27;
		bSizer27 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText11 = new wxStaticText( m_panel3, wxID_ANY, wxT("Start from t [1...Nt] (tmin):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText11->Wrap( -1 );
		m_staticText11->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer27->Add( m_staticText11, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl13 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl13->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer27->Add( m_textCtrl13, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer27, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer28;
		bSizer28 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText12 = new wxStaticText( m_panel3, wxID_ANY, wxT("End with t [tmin+1...Nt]:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText12->Wrap( -1 );
		m_staticText12->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer28->Add( m_staticText12, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl14 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("36"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl14->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer28->Add( m_textCtrl14, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer28, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer29;
		bSizer29 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText13 = new wxStaticText( m_panel3, wxID_ANY, wxT("Value at tmax (beta):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText13->Wrap( -1 );
		m_staticText13->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer29->Add( m_staticText13, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl15 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("6.1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl15->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer29->Add( m_textCtrl15, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer29, 1, wxEXPAND, 5 );
		
		m_staticline2 = new wxStaticLine( m_panel3, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		sbSizer3->Add( m_staticline2, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer30;
		bSizer30 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText14 = new wxStaticText( m_panel3, wxID_ANY, wxT("# of frequency points:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText14->Wrap( -1 );
		m_staticText14->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer30->Add( m_staticText14, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl16 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("1500"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl16->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer30->Add( m_textCtrl16, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer30, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer31;
		bSizer31 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText15 = new wxStaticText( m_panel3, wxID_ANY, wxT("w_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText15->Wrap( -1 );
		m_staticText15->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer31->Add( m_staticText15, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl17 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("-10."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl17->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer31->Add( m_textCtrl17, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer31, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer32;
		bSizer32 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText16 = new wxStaticText( m_panel3, wxID_ANY, wxT("w_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText16->Wrap( -1 );
		m_staticText16->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer32->Add( m_staticText16, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl18 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("20."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl18->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer32->Add( m_textCtrl18, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer32, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer33;
		bSizer33 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText17 = new wxStaticText( m_panel3, wxID_ANY, wxT("Extra Interval (HPNum):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText17->Wrap( -1 );
		m_staticText17->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer33->Add( m_staticText17, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl19 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl19->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer33->Add( m_textCtrl19, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer33, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer34;
		bSizer34 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText18 = new wxStaticText( m_panel3, wxID_ANY, wxT("wHP_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText18->Wrap( -1 );
		m_staticText18->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer34->Add( m_staticText18, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl20 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl20->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer34->Add( m_textCtrl20, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer34, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer35;
		bSizer35 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText19 = new wxStaticText( m_panel3, wxID_ANY, wxT("wHP_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText19->Wrap( -1 );
		m_staticText19->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer35->Add( m_staticText19, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl21 = new wxTextCtrl( m_panel3, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl21->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer35->Add( m_textCtrl21, 1, wxALL, 5 );
		
		sbSizer3->Add( bSizer35, 1, wxEXPAND, 5 );
		
		m_panel3->SetSizer( sbSizer3 );
		m_panel3->Layout();
		sbSizer3->Fit( m_panel3 );
		m_notebook21->AddPage( m_panel3, wxT("Nt/Nw"), false );
		m_panel41 = new wxPanel( m_notebook21, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer8;
		bSizer8 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer4;
		sbSizer4 = new wxStaticBoxSizer( new wxStaticBox( m_panel41, wxID_ANY, wxT("Kernel and Prior") ), wxVERTICAL );
		
		wxBoxSizer* bSizer36;
		bSizer36 = new wxBoxSizer( wxVERTICAL );
		
		wxBoxSizer* bSizer37;
		bSizer37 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText20 = new wxStaticText( m_panel41, wxID_ANY, wxT("Kernel Type:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText20->Wrap( -1 );
		m_staticText20->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer37->Add( m_staticText20, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice2Choices[] = { wxT("exp(-wt)"), wxT("finite T exp()") };
		int m_choice2NChoices = sizeof( m_choice2Choices ) / sizeof( wxString );
		m_choice2 = new wxChoice( m_panel41, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice2NChoices, m_choice2Choices, 0 );
		m_choice2->SetSelection( 0 );
		m_choice2->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer37->Add( m_choice2, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer37, 1, wxEXPAND, 5 );
		
		m_staticline3 = new wxStaticLine( m_panel41, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizer36->Add( m_staticline3, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer38;
		bSizer38 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText21 = new wxStaticText( m_panel41, wxID_ANY, wxT("Prior Form:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText21->Wrap( -1 );
		m_staticText21->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer38->Add( m_staticText21, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice3Choices[] = { wxT("1/(w-w_0)"), wxT("w^(option)"), wxT("const") };
		int m_choice3NChoices = sizeof( m_choice3Choices ) / sizeof( wxString );
		m_choice3 = new wxChoice( m_panel41, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice3NChoices, m_choice3Choices, 0 );
		m_choice3->SetSelection( 0 );
		m_choice3->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer38->Add( m_choice3, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer38, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer39;
		bSizer39 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText22 = new wxStaticText( m_panel41, wxID_ANY, wxT("Prior Amplitude:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText22->Wrap( -1 );
		m_staticText22->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer39->Add( m_staticText22, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl22 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("0.01"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl22->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer39->Add( m_textCtrl22, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer39, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer40;
		bSizer40 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText23 = new wxStaticText( m_panel41, wxID_ANY, wxT("Prior Option:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText23->Wrap( -1 );
		m_staticText23->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer40->Add( m_staticText23, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl23 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl23->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer40->Add( m_textCtrl23, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer36->Add( bSizer40, 1, wxEXPAND, 5 );
		
		sbSizer4->Add( bSizer36, 1, wxEXPAND, 5 );
		
		bSizer8->Add( sbSizer4, 1, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer5;
		sbSizer5 = new wxStaticBoxSizer( new wxStaticBox( m_panel41, wxID_ANY, wxT("Alpha steps") ), wxVERTICAL );
		
		wxBoxSizer* bSizer42;
		bSizer42 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText24 = new wxStaticText( m_panel41, wxID_ANY, wxT("Precondition alpha:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText24->Wrap( -1 );
		m_staticText24->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer42->Add( m_staticText24, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl24 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("5.0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl24->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer42->Add( m_textCtrl24, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer42, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer43;
		bSizer43 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText25 = new wxStaticText( m_panel41, wxID_ANY, wxT("Alpha steps:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText25->Wrap( -1 );
		m_staticText25->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer43->Add( m_staticText25, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl25 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("50"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl25->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer43->Add( m_textCtrl25, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer43, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer44;
		bSizer44 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText26 = new wxStaticText( m_panel41, wxID_ANY, wxT("alpha_max:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText26->Wrap( -1 );
		m_staticText26->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer44->Add( m_staticText26, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl26 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("4.0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl26->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer44->Add( m_textCtrl26, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer44, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer45;
		bSizer45 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText27 = new wxStaticText( m_panel41, wxID_ANY, wxT("alpha_min:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText27->Wrap( -1 );
		m_staticText27->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer45->Add( m_staticText27, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl27 = new wxTextCtrl( m_panel41, wxID_ANY, wxT("0."), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl27->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer45->Add( m_textCtrl27, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer5->Add( bSizer45, 1, wxEXPAND, 5 );
		
		bSizer8->Add( sbSizer5, 1, wxEXPAND, 5 );
		
		m_panel41->SetSizer( bSizer8 );
		m_panel41->Layout();
		bSizer8->Fit( m_panel41 );
		m_notebook21->AddPage( m_panel41, wxT("Kernel/Prior/alpha"), false );
		m_panel5 = new wxPanel( m_notebook21, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer9;
		bSizer9 = new wxBoxSizer( wxVERTICAL );
		
		wxStaticBoxSizer* sbSizer6;
		sbSizer6 = new wxStaticBoxSizer( new wxStaticBox( m_panel5, wxID_ANY, wxT("Minimizer") ), wxVERTICAL );
		
		wxBoxSizer* bSizer46;
		bSizer46 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText28 = new wxStaticText( m_panel5, wxID_ANY, wxT("Algorithm:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText28->Wrap( -1 );
		m_staticText28->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_staticText28, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice4Choices[] = { wxT("LM prec. SVD (EXT)"), wxT("LM prec. SVD"), wxT("LBFGS SVD"), wxT("LBFGS FULL OMEGA") };
		int m_choice4NChoices = sizeof( m_choice4Choices ) / sizeof( wxString );
		m_choice4 = new wxChoice( m_panel5, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice4NChoices, m_choice4Choices, 0 );
		m_choice4->SetSelection( 0 );
		m_choice4->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_choice4, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_staticText35 = new wxStaticText( m_panel5, wxID_ANY, wxT("use:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText35->Wrap( -1 );
		m_staticText35->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_staticText35, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxString m_choice6Choices[] = { wxT("Q(L,S)"), wxT("L"), wxT("S") };
		int m_choice6NChoices = sizeof( m_choice6Choices ) / sizeof( wxString );
		m_choice6 = new wxChoice( m_panel5, wxID_ANY, wxDefaultPosition, wxDefaultSize, m_choice6NChoices, m_choice6Choices, 0 );
		m_choice6->SetSelection( 0 );
		m_choice6->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer46->Add( m_choice6, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer46, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer47;
		bSizer47 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText29 = new wxStaticText( m_panel5, wxID_ANY, wxT("ExtendSVD by:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText29->Wrap( -1 );
		m_staticText29->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_staticText29, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl28 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("12"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl28->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_textCtrl28, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_staticText36 = new wxStaticText( m_panel5, wxID_ANY, wxT("LBFGS #:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText36->Wrap( -1 );
		m_staticText36->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_staticText36, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl35 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("200"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl35->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer47->Add( m_textCtrl35, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer47, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer48;
		bSizer48 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText31 = new wxStaticText( m_panel5, wxID_ANY, wxT("Tolerance (prec./norm.):"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText31->Wrap( -1 );
		m_staticText31->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer48->Add( m_staticText31, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		wxBoxSizer* bSizer57;
		bSizer57 = new wxBoxSizer( wxHORIZONTAL );
		
		m_textCtrl30 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("1e-20"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl30->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer57->Add( m_textCtrl30, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl31 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("1e-10"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl31->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer57->Add( m_textCtrl31, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer48->Add( bSizer57, 1, wxEXPAND, 5 );
		
		sbSizer6->Add( bSizer48, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer49;
		bSizer49 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText32 = new wxStaticText( m_panel5, wxID_ANY, wxT("Max Iterations:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText32->Wrap( -1 );
		m_staticText32->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_staticText32, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl32 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("100000"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl32->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_textCtrl32, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_checkBox1 = new wxCheckBox( m_panel5, wxID_ANY, wxT("ChkSubsp.:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_checkBox1->SetValue(true); 
		m_checkBox1->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_checkBox1, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl34 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("200"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl34->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer49->Add( m_textCtrl34, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer49, 1, wxEXPAND, 5 );
		
		m_staticline4 = new wxStaticLine( m_panel5, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		sbSizer6->Add( m_staticline4, 0, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer52;
		bSizer52 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText37 = new wxStaticText( m_panel5, wxID_ANY, wxT("# of Error Intervals:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText37->Wrap( -1 );
		m_staticText37->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_staticText37, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl36 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("100"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl36->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_textCtrl36, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_checkBox2 = new wxCheckBox( m_panel5, wxID_ANY, wxT("Full Error Matrix"), wxDefaultPosition, wxDefaultSize, 0 );
		m_checkBox2->SetValue(true); 
		m_checkBox2->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer52->Add( m_checkBox2, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer52, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer53;
		bSizer53 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText38 = new wxStaticText( m_panel5, wxID_ANY, wxT("# of Jacknife Intervals:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText38->Wrap( -1 );
		m_staticText38->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer53->Add( m_staticText38, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl37 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl37->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer53->Add( m_textCtrl37, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer6->Add( bSizer53, 1, wxEXPAND, 5 );
		
		bSizer9->Add( sbSizer6, 1, wxEXPAND, 5 );
		
		wxStaticBoxSizer* sbSizer7;
		sbSizer7 = new wxStaticBoxSizer( new wxStaticBox( m_panel5, wxID_ANY, wxT("Mock options") ), wxVERTICAL );
		
		wxBoxSizer* bSizer54;
		bSizer54 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText39 = new wxStaticText( m_panel5, wxID_ANY, wxT("Mock Data generation:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText39->Wrap( -1 );
		m_staticText39->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer54->Add( m_staticText39, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl38 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("0"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl38->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer54->Add( m_textCtrl38, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer54, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer55;
		bSizer55 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText40 = new wxStaticText( m_panel5, wxID_ANY, wxT("Mock Noise ampl.:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText40->Wrap( -1 );
		m_staticText40->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer55->Add( m_staticText40, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl39 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("0.001"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl39->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer55->Add( m_textCtrl39, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer55, 1, wxEXPAND, 5 );
		
		wxBoxSizer* bSizer56;
		bSizer56 = new wxBoxSizer( wxHORIZONTAL );
		
		m_staticText41 = new wxStaticText( m_panel5, wxID_ANY, wxT("Mock option:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticText41->Wrap( -1 );
		m_staticText41->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer56->Add( m_staticText41, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_textCtrl40 = new wxTextCtrl( m_panel5, wxID_ANY, wxT("1"), wxDefaultPosition, wxDefaultSize, 0 );
		m_textCtrl40->SetFont( wxFont( 12, 70, 90, 90, false, wxEmptyString ) );
		
		bSizer56->Add( m_textCtrl40, 1, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		sbSizer7->Add( bSizer56, 1, wxEXPAND, 5 );
		
		bSizer9->Add( sbSizer7, 0, wxEXPAND, 5 );
		
		m_panel5->SetSizer( bSizer9 );
		m_panel5->Layout();
		bSizer9->Fit( m_panel5 );
		m_notebook21->AddPage( m_panel5, wxT("Minimizer"), false );
		
		bSizer1->Add( m_notebook21, 1, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer3;
		bSizer3 = new wxBoxSizer( wxHORIZONTAL );
		
		wxBoxSizer* bSizer11;
		bSizer11 = new wxBoxSizer( wxVERTICAL );
		
		m_notebookTHREAD = new wxNotebook( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, 0 );
		m_panel4 = new wxPanel( m_notebookTHREAD, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		wxBoxSizer* bSizer59;
		bSizer59 = new wxBoxSizer( wxVERTICAL );
		
		m_textCtrl41 = new wxTextCtrl( m_panel4, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY );
		bSizer59->Add( m_textCtrl41, 1, wxALL|wxEXPAND, 5 );
		
		m_gauge1 = new wxGauge( m_panel4, wxID_ANY, 100, wxDefaultPosition, wxDefaultSize, wxGA_HORIZONTAL );
		bSizer59->Add( m_gauge1, 0, wxALL|wxEXPAND, 5 );
		
		m_panel4->SetSizer( bSizer59 );
		m_panel4->Layout();
		bSizer59->Fit( m_panel4 );
		m_notebookTHREAD->AddPage( m_panel4, wxT("Start New MEM"), false );
		
		bSizer11->Add( m_notebookTHREAD, 1, wxEXPAND | wxALL, 5 );
		
		wxBoxSizer* bSizer58;
		bSizer58 = new wxBoxSizer( wxHORIZONTAL );
		
		m_button4 = new wxButton( this, wxID_ANY, wxT("Credits and Legal Info"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button4, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		
		bSizer58->Add( 0, 0, 1, wxEXPAND, 5 );
		
		m_button5 = new wxButton( this, wxID_ANY, wxT("Save Config"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button5, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		m_button6 = new wxButton( this, wxID_ANY, wxT("Load Config"), wxDefaultPosition, wxDefaultSize, 0 );
		bSizer58->Add( m_button6, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		
		bSizer58->Add( 0, 0, 1, wxEXPAND, 5 );
		
		m_button7 = new wxButton( this, wxID_ANY, wxT("Run MEM"), wxDefaultPosition, wxDefaultSize, 0 );
		m_button7->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
		m_button7->SetMinSize( wxSize( -1,45 ) );
		
		bSizer58->Add( m_button7, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5 );
		
		bSizer11->Add( bSizer58, 0, wxEXPAND, 5 );
		
		bSizer3->Add( bSizer11, 2, wxEXPAND, 5 );
		
		bSizer1->Add( bSizer3, 1, wxEXPAND, 5 );
		
		this->SetSizer( bSizer1 );
		this->Layout();
		bSizer1->Fit( this );
	
	}
	
	m_button1->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectDataDir ), NULL, this );
	m_button2->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectDataFname ), NULL, this );
	m_button6->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::LoadConfig ), NULL, this );
	m_button5->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SaveConfig ), NULL, this );
	m_button3->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectResultsDir ), NULL, this );
	m_button7->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::RunMEM ), NULL, this );
	m_button4->Connect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::ShowCredits ), NULL, this );
	
	
}

	//*********************************************************************************
	//	The Menu destructor disconnects any previously registered events from
	//	their functions
	//*********************************************************************************

	MenuBase::~MenuBase()
	{
		m_button1->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectDataDir ), NULL, this );
		m_button2->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectDataFname ), NULL, this );
		m_button6->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::LoadConfig ), NULL, this );
		m_button5->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SaveConfig ), NULL, this );
		m_button3->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::SelectResultsDir ), NULL, this );
		m_button7->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::RunMEM ), NULL, this );
		m_button4->Disconnect( wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler( MenuBase::ShowCredits ), NULL, this );
	
	}
	
	//*********************************************************************************
	//	Implementation of the functions that encode the interaction with the user
	//*********************************************************************************


	//*********************************************************************************
	//	File and Path selection modal dialogs for data directory, data filename 
	//      and folder for the results of the calculation
	//*********************************************************************************
	
	void    MenuBase::SelectDataDir( wxCommandEvent& event ) { 

			
		wxDirDialog *OpenDialog = new wxDirDialog( this, _("Choose a the data directory"), wxEmptyString,
				wxDD_DEFAULT_STYLE | wxDD_DIR_MUST_EXIST);
	
		if (OpenDialog->ShowModal() == wxID_OK)
		{
			m_textCtrl2->Clear();
			wxString sep=wxFileName::GetPathSeparator();
			*m_textCtrl2 << OpenDialog->GetPath() << sep;
	
		}
	    

	}

	void    MenuBase::SelectDataFname( wxCommandEvent& event ) { 

		wxFileDialog *OpenDialog = new wxFileDialog(
			this, _("Choose the data filename"), wxEmptyString, wxEmptyString,
			_("All files (*.*)|*.*"),
			wxFD_FILE_MUST_EXIST, wxDefaultPosition);
			
		if (OpenDialog->ShowModal() == wxID_OK)
		{
			m_textCtrl3->Clear();
			*m_textCtrl3 << OpenDialog->GetFilename();
	
		}
	    

	}

	void    MenuBase::SelectResultsDir( wxCommandEvent& event ) { 

			
		wxDirDialog *OpenDialog = new wxDirDialog( this, _("Choose a the results directory"), wxEmptyString,
				wxDD_DEFAULT_STYLE | wxDD_DIR_MUST_EXIST);
	
		if (OpenDialog->ShowModal() == wxID_OK)
		{
			m_textCtrl4->Clear();
			wxString sep=wxFileName::GetPathSeparator();
			*m_textCtrl4 << OpenDialog->GetPath()<< sep;
	
		}
	    

	}
	
	//*********************************************************************************
	//	Load and Save the values that have been typed into the GUI              
	//*********************************************************************************
#if(0)
	void    MenuBase::LoadConfig( wxCommandEvent& event ) { 

		wxFileDialog *OpenDialog = new wxFileDialog(
			this, _("Choose a config file to load"), wxEmptyString, wxEmptyString,
			_("Mem ConfiG files (*.MCG)|*.*"),
			wxFD_FILE_MUST_EXIST, wxDefaultPosition);

		if (OpenDialog->ShowModal() == wxID_OK)
		{

			wxTextFile ConfigFile( OpenDialog->GetPath() );
			ConfigFile.Open();
				
			if ( ConfigFile.IsOpened() )
			{

				wxString input;
				input=ConfigFile.GetFirstLine();

				input = ConfigFile.GetNextLine();
				m_textCtrl1->Clear();
				*m_textCtrl1<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl2->Clear();
				*m_textCtrl2<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl3->Clear();
				*m_textCtrl3<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl4->Clear();
				*m_textCtrl4<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl5->Clear();
				*m_textCtrl5<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl6->Clear();
				*m_textCtrl6<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl7->Clear();
				*m_textCtrl7<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl8->Clear();
				*m_textCtrl8<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl9->Clear();
				*m_textCtrl9<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl11->Clear();
				*m_textCtrl11<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl12->Clear();
				*m_textCtrl12<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl13->Clear();
				*m_textCtrl13<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl14->Clear();
				*m_textCtrl14<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl15->Clear();
				*m_textCtrl15<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl16->Clear();
				*m_textCtrl16<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl17->Clear();
				*m_textCtrl17<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl18->Clear();
				*m_textCtrl18<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl19->Clear();
				*m_textCtrl19<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl20->Clear();
				*m_textCtrl20<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl21->Clear();
				*m_textCtrl21<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl22->Clear();
				*m_textCtrl22<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl23->Clear();
				*m_textCtrl23<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl24->Clear();
				*m_textCtrl24<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl25->Clear();
				*m_textCtrl25<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl26->Clear();
				*m_textCtrl26<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl27->Clear();
				*m_textCtrl27<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl28->Clear();
				*m_textCtrl28<<input;
				

				input = ConfigFile.GetNextLine();
				m_textCtrl30->Clear();
				*m_textCtrl30<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl31->Clear();
				*m_textCtrl31<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl32->Clear();
				*m_textCtrl32<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl34->Clear();
				*m_textCtrl34<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl35->Clear();
				*m_textCtrl35<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl36->Clear();
				*m_textCtrl36<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl37->Clear();
				*m_textCtrl37<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl38->Clear();
				*m_textCtrl38<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl39->Clear();
				*m_textCtrl39<<input;
				
				input = ConfigFile.GetNextLine();
				m_textCtrl40->Clear();
				*m_textCtrl40<<input;

				input = ConfigFile.GetNextLine();
				m_choice1->SetSelection(wxAtoi(input));

				input = ConfigFile.GetNextLine();
				m_choice2->SetSelection(wxAtoi(input));

				input = ConfigFile.GetNextLine();
				m_choice3->SetSelection(wxAtoi(input));

				input = ConfigFile.GetNextLine();
				m_choice4->SetSelection(wxAtoi(input));

				input = ConfigFile.GetNextLine();
				m_choice6->SetSelection(wxAtoi(input));

				input = ConfigFile.GetNextLine();
				m_checkBox1->SetValue(wxAtoi(input));
				
				input = ConfigFile.GetNextLine();
				m_checkBox2->SetValue(wxAtoi(input));

			}		
		}
	}
#endif

	void    MenuBase::LoadConfig( wxCommandEvent& event ) { 

		wxFileDialog *OpenDialog = new wxFileDialog(
			this, _("Choose a config file to load"), wxEmptyString, wxEmptyString,
			_("Mem ConfiG files (*.MCG)|*.*"),
			wxFD_FILE_MUST_EXIST, wxDefaultPosition);

		if (OpenDialog->ShowModal() == wxID_OK)
		{

			wxTextFile ConfigFile( OpenDialog->GetPath() );
			ConfigFile.Open();
				
			if ( ConfigFile.IsOpened() )
			{
				int starts,ends;
				long valuel;
				double valued;
				
				wxString input,data,tmp;
				input=ConfigFile.GetFirstLine();
				
				for(int i=0;i<8;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				
				if( m_textCtrl1->IsEditable() ){
					starts=input.find(wxT("="),  0);
					ends=input.find(wxT("#"),  0);	
					m_textCtrl1->Clear();
					data=input.substr(starts+1, ends-starts-1);
					data.ToLong(&valuel,10);
					*m_textCtrl1<<valuel;
				}
				
				
				for(int i=0;i<3;i++) input = ConfigFile.GetNextLine();
		
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("\'"),  0);
				ends=input.find(wxT("\'"),  starts+2);	
				data=input.substr(starts+1, ends-starts-2);
				m_textCtrl2->Clear();
				*m_textCtrl2<<data;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("\'"),  0);
				ends=input.find(wxT("\'"),  starts+2);	
				data=input.substr(starts+1, ends-starts-1);
				m_textCtrl3->Clear();
				*m_textCtrl3<<data;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("\'"),  0);
				ends=input.find(wxT("\'"),  starts+2);	
				data=input.substr(starts+1, ends-starts-2);
				m_textCtrl4->Clear();
				*m_textCtrl4<<data;
		
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				m_choice1->SetSelection(valuel-1);
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl5->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl5<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl6->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl6<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl7->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl7<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl8->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl8<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl9->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl9<<valuel;

				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl11->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl11<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl12->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl12<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl13->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl13<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl14->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl14<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl15->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl15<<valued;
				*m_textCtrl15<<data;
				
				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl16->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl16<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl17->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl17<<valued;
				*m_textCtrl17<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl18->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl18<<valued;
				*m_textCtrl18<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl19->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl19<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl20->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl20<<valued;
				*m_textCtrl20<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl21->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl21<<valued;
				*m_textCtrl21<<data;

				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				m_choice2->SetSelection(valuel-1);

				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				
				if(valuel==1){
					m_choice3->SetSelection(1);
				}else if (valuel==2){
					m_choice3->SetSelection(0);
				}else if (valuel==3){
					m_choice3->SetSelection(2);
				}else{
					fprintf(stderr, "Only choices 0-2 are valid\n"); exit(-1);				
				}
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl22->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl22<<valued;
				*m_textCtrl22<<data;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl23->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl23<<valuel;
				
				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl24->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl24<<valued;
				*m_textCtrl24<<data;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl25->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl25<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl26->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl26<<valued;
				*m_textCtrl26<<data;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl27->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl27<<valued;
				*m_textCtrl27<<data;
	
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				
				if(valuel==10){
					m_choice4->SetSelection(0);
				}else if (valuel==6){
					m_choice4->SetSelection(1);
				}else if (valuel==5){
					m_choice4->SetSelection(2);
				}else if (valuel==2){
					m_choice4->SetSelection(3);
				}else{
					fprintf(stderr, "Only choices 10,6,5,2 are valid\n"); exit(-1);				
				}
	
	
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				
				if(valuel==1){
					m_choice6->SetSelection(0);
				}else if (valuel==0){
					m_choice6->SetSelection(1);
				}else if (valuel==2){
					m_choice6->SetSelection(2);
				}else{
					fprintf(stderr, "Only choices 10,6,5,2 are valid\n"); exit(-1);				
				}
	
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl28->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl28<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl35->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl35<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl30->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl30<<valued;
				*m_textCtrl30<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl31->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl31<<valued;
				*m_textCtrl31<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl32->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl32<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl32->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl32<<valuel;

				if(valuel>0){
					m_checkBox1->SetValue(1);
				}else{
					m_checkBox1->SetValue(0);
				}

				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl36->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl36<<valuel;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);

				if(valuel==1){
					m_checkBox2->SetValue(1);
				}else{
					m_checkBox2->SetValue(0);
				}
				
				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl37->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl37<<valuel;
								
				for(int i=0;i<1;i++) input = ConfigFile.GetNextLine();

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl38->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl38<<valuel;
				
				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl39->Clear();
				data=input.substr(starts+1, ends-starts-1);
				tmp=data.Right(1);
				while(tmp==wxT("\t")||tmp== wxT(" ")){
					data.RemoveLast();	
					tmp=data.Right(1);
/*				        char ctmp1[256],ctmp2[256],ctmp3[256];
					strncpy(ctmp1, data.mb_str(wxConvUTF8), 255);
					strncpy(ctmp2, tmp1.mb_str(wxConvUTF8), 255);
					strncpy(ctmp3, tmp2.mb_str(wxConvUTF8), 255);
					fprintf(stderr, "CHECK STRING: %s TMP1:(%s) TMP2:(%s)\n", ctmp1,ctmp2,ctmp3);*/
				}
				//data.ToDouble(&valued);
				//*m_textCtrl39<<valued;
				*m_textCtrl39<<data;

				input = ConfigFile.GetNextLine();
				starts=input.find(wxT("="),  0);
				ends=input.find(wxT("#"),  0);	
				m_textCtrl40->Clear();
				data=input.substr(starts+1, ends-starts-1);
				data.ToLong(&valuel,10);
				*m_textCtrl40<<valuel;

			}		
		}
	}

#if (0)
	void    MenuBase::SaveConfig( wxCommandEvent& event ) { 

		wxFileDialog *OpenDialog = new wxFileDialog(
			this, _("Choose a config file to save"), wxEmptyString, wxEmptyString,
			_("Mem ConfiG files (*.MCG)|*.*"),
			wxFD_SAVE, wxDefaultPosition);

		if (OpenDialog->ShowModal() == wxID_OK) // if the user click "Open" instead of "cancel"
		{

			wxFileOutputStream ConfigFileBase( OpenDialog->GetPath() );
			wxTextOutputStream ConfigFile( ConfigFileBase );
			
			if ( ConfigFileBase.IsOk()) // if the file opened successfully
			{
			    
				ConfigFile << wxT("This is a MEM Configuration File") << endl;
				
				ConfigFile << m_textCtrl1->GetValue() << endl;
				ConfigFile << m_textCtrl2->GetValue() << endl;
				ConfigFile << m_textCtrl3->GetValue() << endl;
				ConfigFile << m_textCtrl4->GetValue() << endl;
				ConfigFile << m_textCtrl5->GetValue() << endl;
				ConfigFile << m_textCtrl6->GetValue() << endl;
				ConfigFile << m_textCtrl7->GetValue() << endl;
				ConfigFile << m_textCtrl8->GetValue() << endl;
				ConfigFile << m_textCtrl9->GetValue() << endl;

				ConfigFile << m_textCtrl11->GetValue() << endl;
				ConfigFile << m_textCtrl12->GetValue() << endl;
				ConfigFile << m_textCtrl13->GetValue() << endl;
				ConfigFile << m_textCtrl14->GetValue() << endl;
				ConfigFile << m_textCtrl15->GetValue() << endl;
				ConfigFile << m_textCtrl16->GetValue() << endl;
				ConfigFile << m_textCtrl17->GetValue() << endl;
				ConfigFile << m_textCtrl18->GetValue() << endl;
				ConfigFile << m_textCtrl19->GetValue() << endl;
				ConfigFile << m_textCtrl20->GetValue() << endl;
				ConfigFile << m_textCtrl21->GetValue() << endl;
				
				ConfigFile << m_textCtrl22->GetValue() << endl;
				ConfigFile << m_textCtrl23->GetValue() << endl;
				ConfigFile << m_textCtrl24->GetValue() << endl;
				ConfigFile << m_textCtrl25->GetValue() << endl;
				ConfigFile << m_textCtrl26->GetValue() << endl;
				ConfigFile << m_textCtrl27->GetValue() << endl;

				ConfigFile << m_textCtrl28->GetValue() << endl;
				ConfigFile << m_textCtrl30->GetValue() << endl;
				ConfigFile << m_textCtrl31->GetValue() << endl;
				ConfigFile << m_textCtrl32->GetValue() << endl;
				ConfigFile << m_textCtrl34->GetValue() << endl;
				ConfigFile << m_textCtrl35->GetValue() << endl;
				ConfigFile << m_textCtrl36->GetValue() << endl;
				ConfigFile << m_textCtrl37->GetValue() << endl;
				ConfigFile << m_textCtrl38->GetValue() << endl;
				ConfigFile << m_textCtrl39->GetValue() << endl;
				ConfigFile << m_textCtrl40->GetValue() << endl;

				ConfigFile << m_choice1->GetSelection() << endl;
				ConfigFile << m_choice2->GetSelection() << endl;
				ConfigFile << m_choice3->GetSelection() << endl;
				ConfigFile << m_choice4->GetSelection() << endl;
				ConfigFile << m_choice6->GetSelection() << endl;
				
				ConfigFile << m_checkBox1->GetValue() << endl;
				ConfigFile << m_checkBox2->GetValue() << endl;
	
			}
		}
	}
#endif

	void    MenuBase::SaveConfig( wxCommandEvent& event ) { 

		wxFileDialog *OpenDialog = new wxFileDialog(
			this, _("Choose a config file to save"), wxEmptyString, wxEmptyString,
			_("Mem ConfiG files (*.MCG)|*.*"),
			wxFD_SAVE, wxDefaultPosition);

		if (OpenDialog->ShowModal() == wxID_OK) // if the user click "Open" instead of "cancel"
		{

			wxFileOutputStream ConfigFileBase( OpenDialog->GetPath() );
			wxTextOutputStream ConfigFile( ConfigFileBase );
			
			if ( ConfigFileBase.IsOk()) // if the file opened successfully
			{

				wxString separator=wxFileName::GetPathSeparator();
				
				ConfigFile << wxT("#!/bin/bash")<< endl<< endl;

				ConfigFile << wxT("  ##########################################################") << endl;
				ConfigFile << wxT("  #  Script to run the MEM analysis                        #") << endl;
				ConfigFile << wxT("  ##########################################################") << endl<< endl<< endl;
				
				ConfigFile << wxT("  EXECUTABLE=\'./MEM.run\'") << endl<< endl;

				ConfigFile << wxT("  Global_Precision=") << m_textCtrl1->GetValue() << wxT("\t\t # The global precision in BITS") << endl<< endl;
				ConfigFile << wxT("  Auxiliary_Precision=") << m_textCtrl1->GetValue() << wxT("\t\t # The global auxiliary precision in BITS (CURRENTLY NOT USED)") << endl<< endl;
				
				ConfigFile << wxT("  Data_Folder=\'") << m_textCtrl2->GetValue() << separator << wxT("\'") << wxT("\t\t # The folder where the measurement data lies") << endl;
				ConfigFile << wxT("  Filename=\'") << m_textCtrl3->GetValue() << wxT("\'") << wxT("\t\t # The filename used forthe measurement data") << endl;
				ConfigFile << wxT("  Results_Folder=\'") << m_textCtrl4->GetValue() << separator << wxT("\'") << wxT("\t\t # The folder where the MEM reconstruction is stored") << endl;

				ConfigFile << wxT("  File_Format=") << m_choice1->GetSelection()+1 << wxT("\t\t\t # The format of the datafile: 0 Multifile Wilson 1 Singlefile Wilson") << endl;
				
				ConfigFile << wxT("  Num_Conf=") << m_textCtrl5->GetValue() << wxT("\t\t # The number of measurements to use (Nconf)") << endl;
				ConfigFile << wxT("  Conf_Offset=") << m_textCtrl6->GetValue() << wxT("\t\t # The number of the measurement to start from") << endl;
				ConfigFile << wxT("  Data_Sets=") << m_textCtrl7->GetValue() << wxT("\t\t # The number of the datasets for each measurement (Nx)") << endl;
				ConfigFile << wxT("  Start_Set=") << m_textCtrl8->GetValue() << wxT("\t\t # The number of the dataset to start from (starts with 0)") << endl;
				ConfigFile << wxT("  End_Set=") << m_textCtrl9->GetValue() << wxT("\t\t # The number of the dataset to end with") << endl << endl;
				
				ConfigFile << wxT("  NT=") << m_textCtrl11->GetValue() << wxT("\t\t # Number of points along the full temporal axis") << endl;
				ConfigFile << wxT("  Num_Tau=") << m_textCtrl12->GetValue() << wxT("\t\t # Number of points along temporal axis stored in the datafile") << endl;
				ConfigFile << wxT("  Tau_Start=") << m_textCtrl13->GetValue() << wxT("\t\t # Use the data from this tau value upward [1:NT]") << endl;
				ConfigFile << wxT("  Tau_End=") << m_textCtrl14->GetValue() << wxT("\t\t # Use the data up to this tau value (Tau_Start:NT]") << endl;
				ConfigFile << wxT("  Beta=") << m_textCtrl15->GetValue() << wxT("\t\t # Set a numerical value for the latest point along the tau interval") << endl<< endl;

				ConfigFile << wxT("  Nomega=") << m_textCtrl16->GetValue() << wxT("\t\t # Number of points along the frequency interval") << endl;
				ConfigFile << wxT("  w_min=") << m_textCtrl17->GetValue() << wxT("\t\t # Numerical value for the start of the frequency interval (any real number, also negative possible)") << endl;
				ConfigFile << wxT("  w_max=") << m_textCtrl18->GetValue() << wxT("\t\t # Numerical value for the end of the frequency interval") << endl;
				ConfigFile << wxT("  HighPrec_Num=") << m_textCtrl19->GetValue() << wxT("\t\t # Number of points reserved for a differently spaced subinterval (smaller than Nomega)") << endl;
				ConfigFile << wxT("  wHP_start=") << m_textCtrl20->GetValue() << wxT("\t\t # Numerical value for the start of the differently spaced subinterval (>=w_min) ") << endl;
				ConfigFile << wxT("  wHP_end=") << m_textCtrl21->GetValue() << wxT("\t\t # Numerical value for the end of the differently spaced subinterval (<=w_max)") << endl << endl;

				ConfigFile << wxT("  Kernel_Type=") << m_choice2->GetSelection()+1 << wxT("\t\t # Kernel Type: 1 zero T exp(-wt) 2 finite temp (exp(-wt)+exp(-w(beta-t)))/(1+exp(-w beta))") << endl<< endl;
				
				if( m_choice3->GetSelection() == 0 ){
						ConfigFile << wxT("  Prior_Type=") << wxT("2") << wxT("\t\t # Prior Type: 1 w^(Prior_Opt) 2 1/(w-w_0) 3 finite temp (exp(-wt)+exp(-w(beta-t)))/(1+exp(-w beta))") << endl;
				}else if ( m_choice3->GetSelection() == 1 ){
						ConfigFile << wxT("  Prior_Type=") << wxT("1") << wxT("\t\t # Prior Type: 1 w^(Prior_Opt) 2 1/(w-w_0) 3 finite temp (exp(-wt)+exp(-w(beta-t)))/(1+exp(-w beta))") << endl;
				}else if ( m_choice3->GetSelection() == 2 ){
						ConfigFile << wxT("  Prior_Type=") << wxT("3") << wxT("\t\t # Prior Type: 1 w^(Prior_Opt) 2 1/(w-w_0) 3 finite temp (exp(-wt)+exp(-w(beta-t)))/(1+exp(-w beta))") << endl;
				}
							
				ConfigFile << wxT("  Prior_Amplitude=") << m_textCtrl22->GetValue() << wxT("\t\t # The value each prior starts with at the minimum frequency") << endl;
				ConfigFile << wxT("  Prior_Opt=") << m_textCtrl23->GetValue() << wxT("\t\t # Used for specifying the (positive) exponent in the choice Prior_Type=1") << endl << endl;
				
				ConfigFile << wxT("  Alpha_Precond=") << m_textCtrl24->GetValue() << wxT("\t\t # The value of alpha we use for the preconsitioning run, where try to minimize Q without a subsequent evaluation of the probabilities and errors") << endl;
				ConfigFile << wxT("  Num_alpha=") << m_textCtrl25->GetValue() << wxT("\t\t # The number of steps to use to traverse the alpha interval") << endl;
				ConfigFile << wxT("  Alpha_max=") << m_textCtrl26->GetValue() << wxT("\t\t # The numerical value for the start of the alpha interval") << endl;
				ConfigFile << wxT("  Alpha_min=") << m_textCtrl27->GetValue() << wxT("\t\t # The numerical value for the end of the alpha interval") << endl;

				if( m_choice4->GetSelection() == 0 ){
					ConfigFile << wxT("  Algorithm=") << wxT("10") << wxT("\t\t # The choice of the Algorithm for the Minimizer") << endl;
				}else if ( m_choice4->GetSelection() == 1 ){
					ConfigFile << wxT("  Algorithm=") << wxT("6") << wxT("\t\t # The choice of the Algorithm for the Minimizer") << endl;
				}else if ( m_choice4->GetSelection() == 2 ){
					ConfigFile << wxT("  Algorithm=") << wxT("5") << wxT("\t\t # The choice of the Algorithm for the Minimizer") << endl;
				}else if ( m_choice4->GetSelection() == 3 ){
					ConfigFile << wxT("  Algorithm=") << wxT("2") << wxT("\t\t # The choice of the Algorithm for the Minimizer") << endl;
				}
				
				if( m_choice6->GetSelection() == 0 ){
						ConfigFile << wxT("  Quantity=") << wxT("1") << wxT("\t\t # The numerical value for the end of the alpha interval") << endl;
				}else if ( m_choice6->GetSelection() == 1 ){
						ConfigFile << wxT("  Quantity=") << wxT("0") << wxT("\t\t # The numerical value for the end of the alpha interval") << endl;
				}else if ( m_choice6->GetSelection() == 2 ){
						ConfigFile << wxT("  Quantity=") << wxT("2") << wxT("\t\t # The numerical value for the end of the alpha interval") << endl;
				}
						
				ConfigFile << wxT("  SVD_Extend=") << m_textCtrl28->GetValue() << wxT("\t\t # The number of (tau) steps by which the SVD search space should be extended") << endl;
				ConfigFile << wxT("  LBFGS_Approx=") << m_textCtrl35->GetValue() << wxT("\t\t # The number of approximations to make for the Hessian in the LBFGS algorithm") << endl;
				ConfigFile << wxT("  Tolerance_Prec=") << m_textCtrl30->GetValue() << wxT("\t\t # The tolerance for the Minimizer to accept a minimum in the preconditioner run") << endl;
				ConfigFile << wxT("  Tolerance_Reg=") << m_textCtrl31->GetValue() << wxT("\t\t # The tolerance for the Minimizer to accept a minimum in the regular runs") << endl;
				ConfigFile << wxT("  Max_Iter=") << m_textCtrl32->GetValue() << wxT("\t\t # The maximum number of iterations for the Minimizer") << endl;
				
				
				if( m_checkBox1-> GetValue() == 1) {
						ConfigFile << wxT("  Chk_SVDDev=") << m_textCtrl34->GetValue() << wxT("\t\t # The number of steps in the Minimizer after which to check the deviation from the SVD space") << endl<< endl;	
				} else {
						ConfigFile << wxT("  Chk_SVDDev=") << wxT("0") << wxT("\t\t # The number of steps in the Minimizer after which to check the deviation from the SVD space") << endl<< endl;
				}
				
				ConfigFile << wxT("  Error_Bins=") << m_textCtrl36->GetValue() << wxT("\t\t # The number Intervals for which the averaged error will be calculated") << endl;
				
				if( m_checkBox2-> GetValue() == 1) {
						ConfigFile << wxT("  Full_Error=") << wxT("1") << wxT("\t\t # Switch to calculate the Full NomegaxNomega Error matrix or only the current local submatrix") << endl<< endl;
				} else {
						ConfigFile << wxT("  Full_Error=") << wxT("0") << wxT("\t\t # Switch to calculate the Full NomegaxNomega Error matrix or only the current local submatrix") << endl<< endl;
				}

				ConfigFile << wxT("  Jacknife_Bins=") << m_textCtrl37->GetValue() << wxT("\t\t # The number Intervals for which the averaged error will be calculated") << endl<< endl;
				
				ConfigFile << wxT("  MockAnalysis=") << m_textCtrl38->GetValue() << wxT("\t\t # If set to 1, the program generates Mock data") << endl;
				ConfigFile << wxT("  MockNoiseAmpl=") << m_textCtrl39->GetValue() << wxT("\t\t # The numerical value for the strength of the noise in the mock data") << endl;
				ConfigFile << wxT("  MockOption=") << m_textCtrl40->GetValue() << wxT("\t\t # Select the shape of the mock spectral function") << endl<< endl<< endl;
				
				ConfigFile << wxT("$EXECUTABLE ") << wxT("$Data_Sets ") << wxT("$End_Set ") << wxT("$NT ") << wxT("$Num_Tau ") << wxT("$Tau_Start ") << wxT("$Tau_End ") << wxT("$Nomega ") << wxT("$w_min ") << wxT("$w_max ") << wxT("$Prior_Opt ") << wxT("$Prior_Amplitude ") << wxT("$Error_Bins ") << wxT("$Num_Conf ") << wxT("$Jacknife_Bins ") << wxT("$Conf_Offset ") << wxT("$Beta ") << wxT("$Data_Folder ") << wxT("$MockAnalysis ") << wxT("$MockNoiseAmpl ") << wxT("$MockOption ") << wxT("$wHP_start ") << wxT("$wHP_end ") << wxT("$HighPrec_Num ") << wxT("$Start_Set ") << wxT("$Alpha_Precond ") << wxT("$Alpha_max ") << wxT("$Alpha_min ") << wxT("$Num_alpha ") << wxT("$Algorithm ") << wxT("$Tolerance_Reg ") << wxT("$Tolerance_Prec ") << wxT("$Max_Iter ") << wxT("$LBFGS_Approx ") << wxT("$Quantity ") << wxT("$SVD_Extend ") << wxT("$Prior_Type ") << wxT("$File_Format ") << wxT("$Filename ") << wxT("$Results_Folder ") << wxT("$Kernel_Type ") << wxT("$Chk_SVDDev ") << wxT("$Global_Precision ")<< wxT("$Auxiliary_Precision ")<< wxT("$Full_Error ")<<endl;
				
			}
		}
	}


	//*********************************************************************************
	//	The functions to show the credits as well as start the actual MEM       
	//*********************************************************************************

	void    MenuBase::ShowCredits ( wxCommandEvent& event ) { 
	    
	  
	    MyCredits *CreditsMenu = new MyCredits(wxT("MEM Credits"));
	    CreditsMenu->CenterOnParent(); 
	    CreditsMenu->Show(true);
		
	  
// 		wxMessageDialog *Credits = new wxMessageDialog(NULL, 
// 		    wxT("This program is an implementation of the Maximum Entropy Method"),wxT("Credits and Legal information"), wxOK | wxICON_EXCLAMATION);
// 	    
// 		if (Credits->ShowModal() == wxID_OK) 
// 		{
// 		    
// 		}
// 		
// 		Credits->Destroy();


	}
	
	void    MenuBase::RunMEM ( wxCommandEvent& event ) { 

	  
		m_textCtrl1->SetEditable(false);
		m_textCtrl1->SetBackgroundColour(*wxLIGHT_GREY);
		//*********************************************************************************
		//	IF WE ARE STARTING A NEW RUN ADD A NEW PANEL IN THE GUI
		//	IF NOT WE NEED TO STOP THE OLD RUN AND CLODE THE PANEL
		//*********************************************************************************
	
		ThreadInfo *MEMNew;
		MEMNew = new ThreadInfo;
		
		MEMNew->threadnotebook=m_notebookTHREAD;
		
// 	fprintf(stderr, "DEBUG1\n");	
		(*MEMNew).threadpanel = new wxPanel( m_notebookTHREAD, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
		
// 	fprintf(stderr, "DEBUG2\n");	
		wxBoxSizer* bSizerTHREADPANEL;
		bSizerTHREADPANEL = new wxBoxSizer( wxVERTICAL );
		
// 	fprintf(stderr, "DEBUG3\n");	
		(*MEMNew).threadtxt = new wxTextCtrl( (*MEMNew).threadpanel, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE );
		
		bSizerTHREADPANEL->Add( (*MEMNew).threadtxt, 1, wxALL|wxEXPAND, 5 );
// 	fprintf(stderr, "DEBUG4\n");	

		
	
		wxStaticLine* m_staticlineNEW;
		m_staticlineNEW = new wxStaticLine( (*MEMNew).threadpanel, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
		bSizerTHREADPANEL->Add( m_staticlineNEW, 0, wxEXPAND | wxALL, 5 );
		
		wxStaticText *m_staticTextNEW;
		m_staticTextNEW= new wxStaticText( (*MEMNew).threadpanel, wxID_ANY, wxT("Progress:"), wxDefaultPosition, wxDefaultSize, 0 );
		m_staticTextNEW->Wrap( -1 );
		bSizerTHREADPANEL->Add( m_staticTextNEW, 0, wxALL, 5 );
		
		(*MEMNew).threadgauge = new wxGauge( (*MEMNew).threadpanel, wxID_ANY, 100, wxDefaultPosition, wxDefaultSize, wxGA_HORIZONTAL );
		bSizerTHREADPANEL->Add( (*MEMNew).threadgauge, 0, wxALL|wxEXPAND, 5 );
	
	
// 		fprintf(stderr, "ADDRESSES: %d %d\n", &(*MEMNew), (*MEMNew).threadtxt);

			
		(*MEMNew).threadpanel->SetSizer( bSizerTHREADPANEL );
		(*MEMNew).threadpanel->Layout();

/*	fprintf(stderr, "DEBUG5\n");	*/
		bSizerTHREADPANEL->Fit( (*MEMNew).threadpanel );	
		
  		wxDateTime starttime = wxDateTime::Now();
		wxString title;
		wxString format;
/*	fprintf(stderr, "DEBUG6\n");	*/
		format << wxT("hh:mm");
		
/*	fprintf(stderr, "DEBUG7\n");	*/
		title << starttime.FormatTime();
		
/*	fprintf(stderr, "DEBUG8\n");	*/
		m_notebookTHREAD->AddPage( (*MEMNew).threadpanel, title , false );
				
/*	fprintf(stderr, "DEBUG9\n");	*/
		Threadlist.push_back(*MEMNew);
// 		fprintf(stderr, "ADDRESSES: %d %d\n", &(*MEMNew), (*MEMNew).threadtxt);

		std::list<ThreadInfo>::iterator Threadt;
		Threadt=Threadlist.end();
		Threadt--;
		
// 		fprintf(stderr, "ADDRESSES: %d %d\n", &(*Threadt), (*Threadt).threadtxt);

		
		
// 	fprintf(stderr, "DEBUG10\n");	
		m_notebookTHREAD->Layout();
// 	fprintf(stderr, "DEBUG11\n");	
		
		
		
	  
		//*********************************************************************************
		//	DISPATCH THE MEM FUNCTION CALL AS A NEW THREAD IN THE BACKGROUND OF THE 
		//	GUI APPLICATION.
		//*********************************************************************************
	  
		std::list<ThreadInfo>::iterator Thread;
		Thread=Threadlist.end();
		Thread--;
// 		fprintf(stderr, "ADDRESSES: %d %d\n", &(*Thread), (*Thread).threadtxt);
		  
		  MEMWorker* t = new MEMWorker(this, &(*Thread) );
		  wxThreadError err = t->Create();
		  
		    if (err != wxTHREAD_NO_ERROR)
		    {
			wxMessageBox( _("Couldn't create MEM Worker thread!") );
		    }
		    
		  err = t->Run();
		  
		    if (err != wxTHREAD_NO_ERROR)
		    {
			wxMessageBox( _("Couldn't run mem Worker thread!") );
		    }
		
		
	}
	
	//*********************************************************************************
	//	Implementation of the main GUI initialization
	//*********************************************************************************


	bool MEMGui::OnInit()
	{

	    MenuBase *MEMMenu = new MenuBase(wxT("The Maximum Entropy Method"));
/*	    TheMainMenu=MEMMenu;*/
	    
	    MEMMenu->Show(true);

	    return true;
	}
